Loading...
Searching...
No Matches
Ogre::VertexAnimationTrack Class Reference
Core » Animation

Specialised AnimationTrack for dealing with changing vertex position information. More...

`#include <OgreAnimationTrack.h>`

Inheritance diagram for Ogre::VertexAnimationTrack:
[legend]

## Public Types

enum | TargetMode : uint8 { TM_SOFTWARE , TM_HARDWARE }
| The target animation mode. More...

## Public Member Functions

| VertexAnimationTrack (Animation *parent, unsigned short handle, VertexAnimationType animType)
| Constructor.
| VertexAnimationTrack (Animation *parent, unsigned short handle, VertexAnimationType animType, VertexData *targetData, TargetMode target=TM_SOFTWARE)
| Constructor, associates with target VertexData and temp buffer (for software).
void | _applyBaseKeyFrame (const KeyFrame *base) override
| Internal method to re-base the keyframes relative to a given keyframe.
VertexAnimationTrack * | _clone (Animation *newParent) const
| Clone this track (internal use only).
void | apply (const TimeIndex &timeIndex, Real weight=1.0, Real scale=1.0f) override
| Applies an animation track to the designated target.
virtual void | applyToVertexData (VertexData *data, const TimeIndex &timeIndex, float weight=1.0, const PoseList *poseList=0)
| As the 'apply' method but applies to specified VertexData instead of associated data.
virtual VertexMorphKeyFrame * | createVertexMorphKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
virtual VertexPoseKeyFrame * | createVertexPoseKeyFrame (Real timePos)
| Creates the single pose KeyFrame and adds it to this animation.
VertexAnimationType | getAnimationType (void) const
| Get the type of vertex animation we're performing.
VertexData * | getAssociatedVertexData (void) const
| Gets the associated VertexData which this track will update.
void | getInterpolatedKeyFrame (const TimeIndex &timeIndex, KeyFrame *kf) const override
| Gets a KeyFrame object which contains the interpolated transforms at the time index specified.
TargetMode | getTargetMode (void) const
| Get the target mode.
bool | getVertexAnimationIncludesNormals () const
| Whether the vertex animation (if present) includes normals.
VertexMorphKeyFrame * | getVertexMorphKeyFrame (unsigned short index) const
| Returns the morph KeyFrame at the specified index.
VertexPoseKeyFrame * | getVertexPoseKeyFrame (unsigned short index) const
| Returns the pose KeyFrame at the specified index.
bool | hasNonZeroKeyFrames (void) const override
| Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.
void | optimise (void) override
| Optimise the current track by removing any duplicate keyframes.
void | setAssociatedVertexData (VertexData *data)
| Sets the associated VertexData which this track will update.
void | setTargetMode (TargetMode m)
| Set the target mode.
Public Member Functions inherited from Ogre::AnimationTrack
| AnimationTrack (Animation *parent, unsigned short handle)
| Constructor.
virtual | ~AnimationTrack ()
virtual void | _buildKeyFrameIndexMap (const std::vector< Real > &keyFrameTimes)
| Internal method to build keyframe time index map to translate global lower bound index to local lower bound index.
virtual void | _collectKeyFrameTimes (std::vector< Real > &keyFrameTimes)
| Internal method to collect keyframe times, in unique, ordered format.
virtual void | _keyFrameDataChanged (void) const
| Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.
virtual KeyFrame * | createKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
unsigned short | getHandle (void) const
| Get the handle associated with this track.
KeyFrame * | getKeyFrame (size_t index) const
| Returns the KeyFrame at the specified index.
float | getKeyFramesAtTime (const TimeIndex &timeIndex, KeyFrame **keyFrame1, KeyFrame **keyFrame2, unsigned short *firstKeyIndex=0) const
| Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.
size_t | getNumKeyFrames (void) const
| Returns the number of keyframes in this animation.
Animation * | getParent () const
| Returns the parent Animation object for this track.
void | removeAllKeyFrames (void)
| Removes all the KeyFrames from this track.
virtual void | removeKeyFrame (unsigned short index)
| Removes a KeyFrame by it's index.
virtual void | setListener (Listener *l)
| Set a listener for this track.

## Detailed Description

Specialised AnimationTrack for dealing with changing vertex position information.

See also
  VertexAnimationType

## Member Enumeration Documentation

## TargetMode

enum Ogre::VertexAnimationTrack::TargetMode : uint8

The target animation mode.

Enumerator
TM_SOFTWARE | Interpolate vertex positions in software.
TM_HARDWARE | Bind keyframe 1 to position, and keyframe 2 to a texture coordinate for interpolation in hardware.

## Constructor & Destructor Documentation

## VertexAnimationTrack() [1/2]

Ogre::VertexAnimationTrack::VertexAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle,
|  | VertexAnimationType | animType )

Constructor.

Referenced by _clone().

## VertexAnimationTrack() [2/2]

Ogre::VertexAnimationTrack::VertexAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle,
|  | VertexAnimationType | animType,
|  | VertexData * | targetData,
|  | TargetMode | target = TM_SOFTWARE )

Constructor, associates with target VertexData and temp buffer (for software).

References TM_SOFTWARE.

## Member Function Documentation

## getAnimationType()

VertexAnimationType Ogre::VertexAnimationTrack::getAnimationType | ( | void |  | ) | const

inline

Get the type of vertex animation we're performing.

## getVertexAnimationIncludesNormals()

bool Ogre::VertexAnimationTrack::getVertexAnimationIncludesNormals | ( |  | ) | const

Whether the vertex animation (if present) includes normals.

## createVertexMorphKeyFrame()

virtual VertexMorphKeyFrame * Ogre::VertexAnimationTrack::createVertexMorphKeyFrame | ( | Real | timePos | ) |

virtual

Creates a new KeyFrame and adds it to this animation at the given time index.

It is better to create KeyFrames in time order.

Parameters

  timePos | The time from which this KeyFrame will apply.

## createVertexPoseKeyFrame()

virtual VertexPoseKeyFrame * Ogre::VertexAnimationTrack::createVertexPoseKeyFrame | ( | Real | timePos | ) |

virtual

Creates the single pose KeyFrame and adds it to this animation.

## getInterpolatedKeyFrame()

void Ogre::VertexAnimationTrack::getInterpolatedKeyFrame | ( | const TimeIndex & | timeIndex,
|  | KeyFrame * | kf ) const

override virtual

Gets a KeyFrame object which contains the interpolated transforms at the time index specified.

The KeyFrame objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'.

Parameters

  timeIndex | The time (in relation to the whole animation sequence)
  kf | Keyframe object to store results

Implements Ogre::AnimationTrack.

## apply()

void Ogre::VertexAnimationTrack::apply | ( | const TimeIndex & | timeIndex,
|  | Real | weight = 1.0,
|  | Real | scale = 1.0f )

override virtual

Applies an animation track to the designated target.

Parameters

  timeIndex | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

Implements Ogre::AnimationTrack.

## applyToVertexData()

virtual void Ogre::VertexAnimationTrack::applyToVertexData | ( | VertexData * | data,
|  | const TimeIndex & | timeIndex,
|  | float | weight = 1.0,
|  | const PoseList * | poseList = 0 )

virtual

As the 'apply' method but applies to specified VertexData instead of associated data.

## getVertexMorphKeyFrame()

VertexMorphKeyFrame * Ogre::VertexAnimationTrack::getVertexMorphKeyFrame | ( | unsigned short | index | ) | const

Returns the morph KeyFrame at the specified index.

## getVertexPoseKeyFrame()

VertexPoseKeyFrame * Ogre::VertexAnimationTrack::getVertexPoseKeyFrame | ( | unsigned short | index | ) | const

Returns the pose KeyFrame at the specified index.

## setAssociatedVertexData()

void Ogre::VertexAnimationTrack::setAssociatedVertexData | ( | VertexData * | data | ) |

inline

Sets the associated VertexData which this track will update.

## getAssociatedVertexData()

VertexData * Ogre::VertexAnimationTrack::getAssociatedVertexData | ( | void |  | ) | const

inline

Gets the associated VertexData which this track will update.

## setTargetMode()

void Ogre::VertexAnimationTrack::setTargetMode | ( | TargetMode | m | ) |

inline

Set the target mode.

## getTargetMode()

TargetMode Ogre::VertexAnimationTrack::getTargetMode | ( | void |  | ) | const

inline

Get the target mode.

## hasNonZeroKeyFrames()

bool Ogre::VertexAnimationTrack::hasNonZeroKeyFrames | ( | void |  | ) | const

override virtual

Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.

Reimplemented from Ogre::AnimationTrack.

## optimise()

void Ogre::VertexAnimationTrack::optimise | ( | void |  | ) |

override virtual

Optimise the current track by removing any duplicate keyframes.

Reimplemented from Ogre::AnimationTrack.

## _clone()

VertexAnimationTrack * Ogre::VertexAnimationTrack::_clone | ( | Animation * | newParent | ) | const

Clone this track (internal use only).

References VertexAnimationTrack().

## _applyBaseKeyFrame()

void Ogre::VertexAnimationTrack::_applyBaseKeyFrame | ( | const KeyFrame * | base | ) |

override virtual

Internal method to re-base the keyframes relative to a given keyframe.

Reimplemented from Ogre::AnimationTrack.

The documentation for this class was generated from the following file:

- OgreAnimationTrack.h